summaryrefslogtreecommitdiff
path: root/www-plugins/gnash
diff options
context:
space:
mode:
Diffstat (limited to 'www-plugins/gnash')
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-amf-include.patch45
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-boost-1.50.patch24
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-cve-2012-1175.patch63
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-gettext-macro.patch170
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-jemalloc-aslr-fix.patch52
-rw-r--r--www-plugins/gnash/files/gnash-0.8.10-npapi-sdk.patch29
-rw-r--r--www-plugins/gnash/files/gnash-0.8.9-external-dejagnu.patch24
-rw-r--r--www-plugins/gnash/files/gnash-0.8.9-kde4-libdir.patch12
-rw-r--r--www-plugins/gnash/files/gnash-0.8.9-klash.patch12
-rw-r--r--www-plugins/gnash/gnash-9999.ebuild287
10 files changed, 718 insertions, 0 deletions
diff --git a/www-plugins/gnash/files/gnash-0.8.10-amf-include.patch b/www-plugins/gnash/files/gnash-0.8.10-amf-include.patch
new file mode 100644
index 0000000..983fa6b
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-amf-include.patch
@@ -0,0 +1,45 @@
+diff -ur a/cygnal/libnet/cque.h b/cygnal/libnet/cque.h
+--- a/cygnal/libnet/cque.h 2012-01-19 20:17:47.000000000 +0100
++++ b/cygnal/libnet/cque.h 2012-02-23 20:13:39.000000000 +0100
+@@ -25,8 +25,9 @@
+ #include <boost/thread/condition.hpp>
+ #include <deque>
+
++#include "../libamf/amf.h"
+ #include "getclocktime.hpp"
+-#include "buffer.h"
++#include "../libamf/buffer.h"
+ #include "network.h"
+ #include "dsodefs.h" //For DSOEXPORT.
+
+diff -ur a/cygnal/libnet/sshclient.h b/cygnal/libnet/sshclient.h
+--- a/cygnal/libnet/sshclient.h 2012-01-19 20:17:47.000000000 +0100
++++ b/cygnal/libnet/sshclient.h 2012-02-23 20:13:09.000000000 +0100
+@@ -32,9 +32,10 @@
+ #include <libssh/sftp.h>
+ }
+
++#include "../libamf/amf.h"
+ #include "cque.h"
+ #include "network.h"
+-#include "buffer.h"
++#include "../libamf/buffer.h"
+
+ namespace gnash
+ {
+diff -ur a/cygnal/libnet/sslclient.h b/cygnal/libnet/sslclient.h
+--- a/cygnal/libnet/sslclient.h 2012-01-19 20:17:47.000000000 +0100
++++ b/cygnal/libnet/sslclient.h 2012-02-23 20:13:21.000000000 +0100
+@@ -36,10 +36,11 @@
+ #include <openssl/err.h>
+ #endif
+
++#include "../libamf/amf.h"
+ #include "dsodefs.h"
+ #include "cque.h"
+ #include "network.h"
+-#include "buffer.h"
++#include "../libamf/buffer.h"
+
+
+ namespace gnash
diff --git a/www-plugins/gnash/files/gnash-0.8.10-boost-1.50.patch b/www-plugins/gnash/files/gnash-0.8.10-boost-1.50.patch
new file mode 100644
index 0000000..ed774ed
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-boost-1.50.patch
@@ -0,0 +1,24 @@
+diff -ur a/macros/boost.m4 b/macros/boost.m4
+--- a/macros/boost.m4 2012-09-03 17:11:43.000000000 +0200
++++ b/macros/boost.m4 2012-10-16 01:58:28.000000000 +0200
+@@ -37,7 +37,7 @@
+ boost_headers="detail/lightweight_mutex.hpp thread/thread.hpp multi_index_container.hpp multi_index/key_extractors.hpp thread/mutex.hpp program_options/options_description.hpp iostreams/stream.hpp"
+ dnl this is a list of *required* libraries. If any of these are missing, this
+ dnl test will return a failure, and Gnash won't build.
+- boost_libs="thread program_options iostreams"
++ boost_libs="thread program_options iostreams system"
+
+ dnl this is a list of *recommended* libraries. If any of these are missing, this
+ dnl test will return a warning, and Gnash will build, but testing won't work.
+diff -ur a/plugin/npapi/Makefile.am b/plugin/npapi/Makefile.am
+--- a/plugin/npapi/Makefile.am 2012-09-03 17:11:43.000000000 +0200
++++ b/plugin/npapi/Makefile.am 2012-10-16 01:58:57.000000000 +0200
+@@ -78,7 +78,7 @@
+
+ libgnashplugin_la_LIBADD = \
+ $(GLIB_LIBS) \
+- -lboost_iostreams \
++ $(BOOST_LIBS) \
+ $(NULL)
+
+ # Scriptable plugin support
diff --git a/www-plugins/gnash/files/gnash-0.8.10-cve-2012-1175.patch b/www-plugins/gnash/files/gnash-0.8.10-cve-2012-1175.patch
new file mode 100644
index 0000000..9a218d9
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-cve-2012-1175.patch
@@ -0,0 +1,63 @@
+From bb4dc77eecb6ed1b967e3ecbce3dac6c5e6f1527 Mon Sep 17 00:00:00 2001
+From: Benjamin Wolsey <bwy@benjaminwolsey.de>
+Date: Sat, 10 Mar 2012 14:52:50 +0000
+Subject: Fix crash in GnashImage.cpp
+
+---
+diff --git a/libbase/GnashImage.cpp b/libbase/GnashImage.cpp
+index 11c6956..03a6939 100644
+--- a/libbase/GnashImage.cpp
++++ b/libbase/GnashImage.cpp
+@@ -26,6 +26,7 @@
+ #include <boost/scoped_array.hpp>
+ #include <boost/shared_ptr.hpp>
+ #include <algorithm>
++#include <cassert>
+
+ #ifdef USE_PNG
+ # include "GnashImagePng.h"
+@@ -44,6 +45,21 @@ namespace image {
+
+ namespace {
+ void processAlpha(GnashImage::iterator imageData, size_t pixels);
++ bool checkValidSize(size_t width, size_t height, size_t channels) {
++
++ if (width == 0 || height == 0) return false;
++
++ assert(channels > 0);
++
++ boost::uint32_t maxSize = std::numeric_limits<boost::int32_t>::max();
++ if (width >= maxSize || height >= maxSize) return false;
++
++ maxSize /= channels;
++ maxSize /= width;
++ maxSize /= height;
++
++ return maxSize > 0;
++ }
+ }
+
+ GnashImage::GnashImage(iterator data, size_t width, size_t height,
+@@ -55,6 +71,8 @@ GnashImage::GnashImage(iterator data, size_t width, size_t height,
+ _height(height),
+ _data(data)
+ {
++ // Callers should check dimensions
++ assert(checkValidSize(_width, _height, channels()));
+ }
+
+ /// Create an image allocating a buffer of height*pitch bytes
+@@ -66,8 +84,9 @@ GnashImage::GnashImage(size_t width, size_t height, ImageType type,
+ _width(width),
+ _height(height)
+ {
+- const size_t max = std::numeric_limits<boost::int32_t>::max();
+- if (size() > max) {
++ // Constructed from external input, so restrict dimensions to avoid
++ // overflow in size calculations
++ if (!checkValidSize(_width, _height, channels())) {
+ throw std::bad_alloc();
+ }
+ _data.reset(new value_type[size()]);
+--
+cgit v0.9.0.2
diff --git a/www-plugins/gnash/files/gnash-0.8.10-gettext-macro.patch b/www-plugins/gnash/files/gnash-0.8.10-gettext-macro.patch
new file mode 100644
index 0000000..0501f74
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-gettext-macro.patch
@@ -0,0 +1,170 @@
+diff -ur a/libdevice/vaapi/VaapiImage.cpp b/libdevice/vaapi/VaapiImage.cpp
+--- a/libdevice/vaapi/VaapiImage.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/vaapi/VaapiImage.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -35,7 +35,7 @@
+ : _format(format)
+ , _image_data(NULL)
+ {
+- log_debug(_("VaapiImage::VaapiImage(): format '%s'\n", string_of_FOURCC(format)));
++ log_debug("VaapiImage::VaapiImage(): format '%s'\n", string_of_FOURCC(format));
+
+ memset(&_image, 0, sizeof(_image));
+ _image.image_id = VA_INVALID_ID;
+@@ -79,7 +79,7 @@
+ if (!vaapi_check_status(status, "vaCreateImage()"))
+ return false;
+
+- log_debug(_(" image 0x%08x, format '%s'\n", get(), string_of_FOURCC(_format)));
++ log_debug(" image 0x%08x, format '%s'\n", get(), string_of_FOURCC(_format));
+
+ return true;
+ }
+diff -ur a/libdevice/vaapi/VaapiSubpicture.cpp b/libdevice/vaapi/VaapiSubpicture.cpp
+--- a/libdevice/vaapi/VaapiSubpicture.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/vaapi/VaapiSubpicture.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -32,7 +32,7 @@
+ : _image(image)
+ , _subpicture(VA_INVALID_ID)
+ {
+- log_debug(_("VaapiSubpicture::VaapiSubpicture(): format '%s'\n", string_of_FOURCC(image->format())));
++ log_debug("VaapiSubpicture::VaapiSubpicture(): format '%s'\n", string_of_FOURCC(image->format()));
+
+ if (!create()) {
+ boost::format msg;
+diff -ur a/libdevice/vaapi/VaapiSurface.cpp b/libdevice/vaapi/VaapiSurface.cpp
+--- a/libdevice/vaapi/VaapiSurface.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/vaapi/VaapiSurface.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -74,7 +74,7 @@
+
+ VaapiSurfaceImpl::~VaapiSurfaceImpl()
+ {
+- log_debug(_("VaapiSurface::~VaapiSurface(): surface 0x%08x\n", surface()));
++ log_debug("VaapiSurface::~VaapiSurface(): surface 0x%08x\n", surface());
+
+ if (surface() == VA_INVALID_SURFACE) {
+ return;
+diff -ur a/libdevice/vaapi/VaapiSurfaceGLX.cpp b/libdevice/vaapi/VaapiSurfaceGLX.cpp
+--- a/libdevice/vaapi/VaapiSurfaceGLX.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/vaapi/VaapiSurfaceGLX.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -202,14 +202,14 @@
+
+ reset(reinterpret_cast<uintptr_t>(surface));
+
+- log_debug(_(" -> surface %p\n", this->surface()));
++ log_debug(" -> surface %p\n", this->surface());
+ }
+
+ VaapiSurfaceGLXImpl::~VaapiSurfaceGLXImpl()
+ {
+ // GNASH_REPORT_FUNCTION;
+
+- log_debug(_("VaapiSurface::~VaapiSurface(): surface %p\n", surface()));
++ log_debug("VaapiSurface::~VaapiSurface(): surface %p\n", surface());
+
+ if (!surface()) {
+ return;
+@@ -263,7 +263,7 @@
+
+ bool VaapiSurfaceGLX::update(boost::shared_ptr<VaapiSurface> surface)
+ {
+- log_debug(_("VaapiSurfaceGLX::update(): from surface 0x%08x\n", surface->get()));
++ log_debug("VaapiSurfaceGLX::update(): from surface 0x%08x\n", surface->get());
+
+ return dynamic_cast<VaapiSurfaceGLXImpl *>(_impl.get())->update(surface);
+ }
+diff -ur a/libdevice/vaapi/VaapiSurfaceProxy.cpp b/libdevice/vaapi/VaapiSurfaceProxy.cpp
+--- a/libdevice/vaapi/VaapiSurfaceProxy.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/vaapi/VaapiSurfaceProxy.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -28,12 +28,12 @@
+ boost::shared_ptr<VaapiContext> context)
+ : _context(context), _surface(surface)
+ {
+- log_debug(_("VaapiSurfaceProxy::VaapiSurfaceProxy(): surface 0x%08x\n", _surface->get()));
++ log_debug("VaapiSurfaceProxy::VaapiSurfaceProxy(): surface 0x%08x\n", _surface->get());
+ }
+
+ VaapiSurfaceProxy::~VaapiSurfaceProxy()
+ {
+- log_debug(_("VaapiSurfaceProxy::~VaapiSurfaceProxy(): surface 0x%08x\n", _surface->get()));
++ log_debug("VaapiSurfaceProxy::~VaapiSurfaceProxy(): surface 0x%08x\n", _surface->get());
+
+ _context->releaseSurface(_surface);
+ }
+diff -ur a/libdevice/x11/X11Device.cpp b/libdevice/x11/X11Device.cpp
+--- a/libdevice/x11/X11Device.cpp 2012-01-19 20:17:48.000000000 +0100
++++ b/libdevice/x11/X11Device.cpp 2012-02-23 19:05:13.000000000 +0100
+@@ -85,7 +85,7 @@
+ GNASH_REPORT_FUNCTION;
+
+ if (!initDevice(0, 0)) {
+- log_error(_("Couldn't initialize X11 device!"));
++ log_error("Couldn't initialize X11 device!");
+ }
+ }
+
+@@ -103,7 +103,7 @@
+ GNASH_REPORT_FUNCTION;
+
+ if (!initDevice(argc, argv)) {
+- log_error(_("Couldn't initialize X11 device!"));
++ log_error("Couldn't initialize X11 device!");
+ }
+ }
+
+@@ -139,7 +139,7 @@
+
+ _display = XOpenDisplay(dpyName);
+ if (!_display) {
+- log_error(_("couldn't open X11 display!"));
++ log_error("couldn't open X11 display!");
+ return false;
+ }
+
+@@ -159,7 +159,7 @@
+ _vinfo = XGetVisualInfo(_display, VisualIDMask, &visTemplate, &num_visuals);
+ std::cerr << "Num Visuals: " << num_visuals << std::endl;
+ if (!_vinfo) {
+- log_error(_("Error: couldn't get X visual\n"));
++ log_error("Error: couldn't get X visual\n");
+ exit(1);
+ }
+ std::cerr << "X11 visual is: " << _vinfo->visual << std::endl;
+@@ -196,7 +196,7 @@
+ if (_display) {
+ XGetErrorText(_display, error, msg, 80);
+ } else {
+- log_error(_("The default Display is not set!"));
++ log_error("The default Display is not set!");
+ }
+
+ return msg;
+@@ -209,12 +209,12 @@
+ GNASH_REPORT_FUNCTION;
+
+ if (!_display) {
+- log_error(_("No Display device set!"));
++ log_error("No Display device set!");
+ return;
+ }
+
+ if (!_root) {
+- log_error(_("No drawable window set!"));
++ log_error("No drawable window set!");
+ return;
+ }
+
+@@ -279,11 +279,11 @@
+ case KeyPress:
+ {
+ char buffer[10];
+- int code;
++ int r, code;
+ code = XLookupKeysym(&event.xkey, 0);
+ if (!keyPress || !keyPress(code)) {
+- // int r = XLookupString(&event.xkey, buffer, sizeof(buffer),
+- // NULL, NULL);
++ r = XLookupString(&event.xkey, buffer, sizeof(buffer),
++ NULL, NULL);
+ if (buffer[0] == 27) {
+ // escape
+ return;
diff --git a/www-plugins/gnash/files/gnash-0.8.10-jemalloc-aslr-fix.patch b/www-plugins/gnash/files/gnash-0.8.10-jemalloc-aslr-fix.patch
new file mode 100644
index 0000000..413744c
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-jemalloc-aslr-fix.patch
@@ -0,0 +1,52 @@
+diff -Naur gnash-0.8.10.alt/libbase/jemalloc.c gnash-0.8.10/libbase/jemalloc.c
+--- gnash-0.8.10.alt/libbase/jemalloc.c 2012-02-07 09:39:41.000000000 +0100
++++ gnash-0.8.10/libbase/jemalloc.c 2012-02-24 18:36:47.000000000 +0100
+@@ -429,7 +429,7 @@
+ static const bool __isthreaded = true;
+ #endif
+
+-#if defined(MOZ_MEMORY_SOLARIS) && defined(MAP_ALIGN) && !defined(JEMALLOC_NEVER_USES_MAP_ALIGN)
++#if defined(MOZ_MEMORY_SOLARIS) && defined(MAP_ALIGN) && !defined(JEMALLOC_NEVER_USES_MAP_ALIGN) || defined(MOZ_MEMORY_LINUX)
+ #define JEMALLOC_USES_MAP_ALIGN /* Required on Solaris 10. Might improve performance elsewhere. */
+ #endif
+
+@@ -2238,6 +2238,7 @@
+ * We don't use MAP_FIXED here, because it can cause the *replacement*
+ * of existing mappings, and we only want to create new mappings.
+ */
++#ifdef MOZ_MEMORY_SOLARIS
+ #ifdef MALLOC_PAGEFILE
+ if (pfd != -1) {
+ ret = mmap((void *)alignment, size, PROT_READ | PROT_WRITE, MAP_PRIVATE |
+@@ -2252,6 +2253,31 @@
+
+ if (ret == MAP_FAILED)
+ ret = NULL;
++#else /* !MOZ_MEMORY_SOLARIS */
++#ifdef MALLOC_PAGEFILE
++ if (pfd != -1) {
++ ret = mmap((void *)alignment, size, PROT_READ | PROT_WRITE, MAP_PRIVATE |
++ MAP_NOSYNC, pfd, 0);
++ } else
++#endif
++ {
++ ret = mmap(NULL, size + alignment, PROT_READ | PROT_WRITE, MAP_PRIVATE |
++ MAP_NOSYNC | MAP_ANON, -1, 0);
++ }
++ assert(ret != NULL);
++
++ if (ret == MAP_FAILED)
++ return NULL;
++
++ uintptr_t aligned_ret;
++ size_t extra_size;
++ aligned_ret = (uintptr_t)ret + alignment - 1;
++ aligned_ret &= ~(alignment - 1);
++ extra_size = aligned_ret - (uintptr_t)ret;
++ munmap(ret, extra_size);
++ munmap(ret + extra_size + size, alignment - extra_size);
++ ret = (void*)aligned_ret;
++#endif /* ifdef MOZ_MEMORY_SOLARIS*/
+ return (ret);
+ }
+ #endif
diff --git a/www-plugins/gnash/files/gnash-0.8.10-npapi-sdk.patch b/www-plugins/gnash/files/gnash-0.8.10-npapi-sdk.patch
new file mode 100644
index 0000000..eb54295
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.10-npapi-sdk.patch
@@ -0,0 +1,29 @@
+From 983a675c94ecec54ae14593744aa9a2198466499 Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Micha=C5=82=20G=C3=B3rny?= <mgorny@gentoo.org>
+Date: Thu, 15 Sep 2011 12:59:55 +0200
+Subject: [PATCH] Support building against NPAPI-SDK as well.
+
+---
+ macros/npapi.m4 | 6 +++++-
+ 1 files changed, 5 insertions(+), 1 deletions(-)
+
+diff --git a/macros/npapi.m4 b/macros/npapi.m4
+index e3bde2f..522bbb1 100644
+--- a/macros/npapi.m4
++++ b/macros/npapi.m4
+@@ -34,7 +34,11 @@ AC_DEFUN([GNASH_PATH_NPAPI],
+
+ if test x$cross_compiling = xno; then
+ if test x"$PKG_CONFIG" != x -a x"${ac_cv_path_npapi_incl}" = x; then
+- $PKG_CONFIG --exists mozilla-plugin && NPAPI_CFLAGS="`$PKG_CONFIG --cflags mozilla-plugin`"
++ if $PKG_CONFIG --exists npapi-sdk; then
++ NPAPI_CFLAGS="`$PKG_CONFIG --cflags npapi-sdk`"
++ elif $PKG_CONFIG --exists mozilla-plugin; then
++ NPAPI_CFLAGS="`$PKG_CONFIG --cflags mozilla-plugin`"
++ fi
+ fi
+ fi
+
+--
+1.7.3.4
+
diff --git a/www-plugins/gnash/files/gnash-0.8.9-external-dejagnu.patch b/www-plugins/gnash/files/gnash-0.8.9-external-dejagnu.patch
new file mode 100644
index 0000000..eaffda7
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.9-external-dejagnu.patch
@@ -0,0 +1,24 @@
+diff -ur a/plugin/npapi/test.cpp b/plugin/npapi/test.cpp
+--- a/plugin/npapi/test.cpp 2011-03-13 17:47:36.000000000 +0100
++++ b/plugin/npapi/test.cpp 2011-03-20 23:52:20.369998096 +0100
+@@ -35,7 +35,7 @@
+ #include "npfunctions.h"
+ #endif
+ #include "pluginbase.h"
+-#include "dejagnu.h"
++#include <dejagnu.h>
+ #include "../../testsuite/check.h"
+ #include <regex.h>
+
+diff -ur a/testsuite/check.h b/testsuite/check.h
+--- a/testsuite/check.h 2011-02-26 19:11:08.000000000 +0100
++++ b/testsuite/check.h 2011-03-20 23:52:32.570998094 +0100
+@@ -29,7 +29,7 @@
+
+ #define HAVE_DEJAGNU_H 1 // we ship our own now...
+ #ifdef HAVE_DEJAGNU_H
+-#include "dejagnu.h"
++#include <dejagnu.h>
+
+ #define info(x) note x
+
diff --git a/www-plugins/gnash/files/gnash-0.8.9-kde4-libdir.patch b/www-plugins/gnash/files/gnash-0.8.9-kde4-libdir.patch
new file mode 100644
index 0000000..b327944
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.9-kde4-libdir.patch
@@ -0,0 +1,12 @@
+diff -ur a/macros/kde4.m4 b/macros/kde4.m4
+--- a/macros/kde4.m4 2011-02-26 19:11:08.000000000 +0100
++++ b/macros/kde4.m4 2011-11-25 18:09:25.000000000 +0100
+@@ -198,7 +198,7 @@
+ if test -d ${KDE4_PREFIX}/lib64 -a -f /etc/redhat-release; then
+ KDE4_PLUGINDIR="${KDE4_PREFIX}/lib64/kde4"
+ else
+- KDE4_PLUGINDIR="${KDE4_PREFIX}/lib/kde4"
++ KDE4_PLUGINDIR="${KDE4_PREFIX}/${acl_libdirstem}/kde4"
+ fi
+ fi
+ if test x"${with_kde4_servicesdir}" != x ; then
diff --git a/www-plugins/gnash/files/gnash-0.8.9-klash.patch b/www-plugins/gnash/files/gnash-0.8.9-klash.patch
new file mode 100644
index 0000000..e6afec0
--- /dev/null
+++ b/www-plugins/gnash/files/gnash-0.8.9-klash.patch
@@ -0,0 +1,12 @@
+diff -ur a/macros/kde4.m4 b/macros/kde4.m4
+--- a/macros/kde4.m4 2011-02-26 19:11:08.000000000 +0100
++++ b/macros/kde4.m4 2011-03-21 00:04:38.845997945 +0100
+@@ -210,7 +210,7 @@
+ KDE4_CONFIGDIR="${KDE4_PREFIX}/share/kde4/config"
+ fi
+ if test x"${KDE4_APPSDATADIR}" = x ; then
+- KDE4_APPSDATADIR="${KDE4_PREFIX}/share/kde4/apps/klash"
++ KDE4_APPSDATADIR="${KDE4_PREFIX}/share/apps/klash"
+ fi
+
+ if test x"${ac_cv_path_kde4_incl}" != x ; then
diff --git a/www-plugins/gnash/gnash-9999.ebuild b/www-plugins/gnash/gnash-9999.ebuild
new file mode 100644
index 0000000..1cb144b
--- /dev/null
+++ b/www-plugins/gnash/gnash-9999.ebuild
@@ -0,0 +1,287 @@
+# Copyright 1999-2012 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/www-plugins/gnash/gnash-0.8.10_p20120903.ebuild,v 1.2 2012/10/31 17:26:47 flameeyes Exp $
+
+EAPI=4
+CMAKE_REQUIRED="never"
+KDE_REQUIRED="optional"
+AT_M4DIR="cygnal"
+PYTHON_DEPEND="python? 2"
+RESTRICT_PYTHON_ABIS="3.*"
+
+inherit autotools eutils kde4-base multilib nsplugins python flag-o-matic
+
+DESCRIPTION="GNU Flash movie player that supports many SWF v7,8,9 features"
+HOMEPAGE="http://www.gnu.org/software/gnash/"
+
+if [[ ${PV} = 9999* ]]; then
+ SRC_URI=""
+ EGIT_REPO_URI="git://git.savannah.gnu.org/gnash.git"
+ inherit git-2
+else
+# Release tarball is b0rked, upstream #35612
+# SRC_URI="mirror://gnu/${PN}/${PV}/${P}.tar.bz2"
+ SRC_URI="mirror://gentoo/${P}.tar.xz"
+fi
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS=""
+IUSE="X +agg cairo cygnal dbus directfb doc dump egl fbcon +ffmpeg gconf gnome gstreamer gtk harden kde lirc mysql +nls nsplugin opengl openvg python sdl +sdl-sound ssh ssl test vaapi"
+REQUIRED_USE="dump? ( agg ffmpeg )
+ fbcon? ( agg )
+ nsplugin? ( gtk )
+ openvg? ( egl )
+ python? ( gtk )
+ vaapi? ( agg ffmpeg )
+ || ( agg cairo opengl openvg )
+ || ( dump fbcon gtk kde sdl )
+ "
+
+RDEPEND=">=dev-libs/boost-1.41.0
+ dev-libs/expat
+ dev-libs/libxml2
+ virtual/jpeg
+ media-libs/libpng
+ net-misc/curl
+ x11-libs/libX11
+ x11-libs/libXi
+ x11-libs/libXmu
+ x11-libs/libXt
+ media-libs/giflib
+ x11-proto/xproto
+ agg? ( x11-libs/agg )
+ cairo? ( x11-libs/cairo )
+ directfb? (
+ dev-libs/DirectFB
+ )
+ doc? (
+ >=app-text/docbook2X-0.8.8
+ app-text/docbook-sgml-utils
+ )
+ egl? (
+ media-libs/mesa[egl]
+ )
+ fbcon? (
+ x11-libs/tslib
+ )
+ ffmpeg? (
+ virtual/ffmpeg[vaapi?]
+ )
+ gconf? (
+ gnome-base/gconf
+ )
+ gstreamer? (
+ media-plugins/gst-plugins-ffmpeg
+ media-plugins/gst-plugins-mad
+ media-plugins/gst-plugins-meta
+ )
+ gtk? (
+ x11-libs/gtk+:2
+ python? ( dev-python/pygtk:2 )
+ )
+ kde? ( $(add_kdebase_dep kdebase-startkde) )
+ opengl? (
+ virtual/glu
+ virtual/opengl
+ gtk? ( x11-libs/gtkglext )
+ )
+ openvg? (
+ media-libs/mesa[openvg]
+ )
+ sdl? ( media-libs/libsdl[X] )
+ sdl-sound? ( media-libs/libsdl )
+ media-libs/speex[ogg]
+ sys-libs/zlib
+ >=sys-devel/libtool-2.2
+ mysql? ( virtual/mysql )
+ lirc? ( app-misc/lirc )
+ dbus? ( sys-apps/dbus )
+ ssh? ( >=net-libs/libssh-0.4[server] )
+ ssl? ( dev-libs/openssl )
+ vaapi? ( x11-libs/libva[opengl?] )
+ "
+DEPEND="${RDEPEND}
+ virtual/pkgconfig
+ nls? ( sys-devel/gettext )
+ gnome? ( app-text/rarian )
+ nsplugin? ( net-misc/npapi-sdk )
+ test? ( dev-util/dejagnu )"
+# Tests hang with sandbox, bug #321017
+RESTRICT="test"
+
+pkg_setup() {
+ kde4-base_pkg_setup
+
+ if use !ffmpeg && use !gstreamer; then
+ ewarn "You are trying to build Gnash without choosing a media handler."
+ ewarn "Sound and video playback will not work."
+ fi
+
+ # won't build with python-3, bug #392969
+ if use python; then
+ python_set_active_version 2
+ fi
+}
+
+#src_unpack() {
+# default
+# # rename git snapshot directory to what portage expects
+# mv ${PN}-*/ ${P} || die
+#}
+
+src_prepare() {
+ # Fix paths for klash, bug #339610
+ epatch "${FILESDIR}"/${PN}-0.8.9-klash.patch
+
+ # Use external dejagnu for tests, bug #321017
+ epatch "${FILESDIR}"/${PN}-0.8.9-external-dejagnu.patch
+
+ # Fix building on ppc64, bug #342535
+ use ppc64 && append-flags -mminimal-toc
+
+ # Fix kde multilib library path, bug #391283
+ epatch "${FILESDIR}"/${PN}-0.8.9-kde4-libdir.patch
+
+ # Fix gettext macros build failure
+ epatch "${FILESDIR}"/${PN}-0.8.10-gettext-macro.patch
+
+ # Fix libamf includes
+ epatch "${FILESDIR}"/${PN}-0.8.10-amf-include.patch
+
+ # Allow building against npapi-sdk, bug #383071
+ epatch "${FILESDIR}"/${PN}-0.8.10-npapi-sdk.patch
+
+ # Allow building against boost-1.50, bug #425442
+ epatch "${FILESDIR}"/${PN}-0.8.10-boost-1.50.patch
+
+ eautoreconf
+}
+src_configure() {
+ local device gui input media myconf myext renderers
+
+ # Set nsplugin install directory.
+ use nsplugin && myconf="${myconf} --with-npapi-plugindir=/usr/$(get_libdir)/gnash/npapi/"
+
+ # Set hardware acceleration.
+ use X && device+=",x11"
+ use directfb && device+=",directfb"
+ use egl && device+=",egl"
+ use fbcon && device+=",rawfb"
+ use vaapi && device+=",vaapi"
+ [[ "${device}x" == "x" ]] && device+=",none"
+
+ # Set rendering engine.
+ use agg && renderers+=",agg"
+ use cairo && renderers+=",cairo"
+ use opengl && renderers+=",opengl"
+ use openvg && renderers+=",openvg"
+
+ # Set kde and konqueror plugin directories.
+ if use kde; then
+ myconf="${myconf}
+ --with-plugins-install=system
+ --with-kde4-incl=${KDEDIR}/include
+ --with-kde4-configdir=${KDEDIR}/share/config
+ --with-kde4-prefix=${KDEDIR}
+ --with-kde4-lib=${KDEDIR}/$(get_libdir)
+ --with-kde-appsdatadir=${KDEDIR}/share/apps/klash
+ --with-kde4-servicesdir=${KDEDIR}/share/kde4/services
+ --with-kde4-plugindir=${KDEDIR}/$(get_libdir)/kde4"
+ fi
+
+ # Set media handler.
+ use ffmpeg || use gstreamer || media+=",none"
+ use ffmpeg && media+=",ffmpeg"
+ use gstreamer && media+=",gst"
+
+ # Set gui.
+ use dump && gui="${gui},dump"
+ use fbcon && gui="${gui},fb"
+ use gtk && gui=",gtk"
+ use kde && gui="${gui},kde4"
+ use sdl && gui="${gui},sdl"
+
+ if use sdl-sound; then
+ myconf="${myconf} --enable-sound=sdl"
+ else
+ myconf="${myconf} --enable-sound=none"
+ fi
+
+ # Set extensions
+ use mysql && myext=",mysql"
+ use gtk && myext="${myext},gtk"
+ use lirc && myext="${myext},lirc"
+ use dbus && myext="${myext},dbus"
+
+ # Strip extra comma from gui, myext, hwaccel and renderers.
+ device=$( echo $device | sed -e 's/,//' )
+ gui=$( echo $gui | sed -e 's/,//' )
+ myext=$( echo $myext | sed -e 's/,//' )
+ renderers=$( echo $renderers | sed -e 's/,//' )
+ media=$( echo $media | sed -e 's/,//' )
+
+ econf \
+ --docdir=/usr/share/doc/${PF} \
+ --disable-dependency-tracking \
+ --disable-kparts3 \
+ $(use_enable cygnal) \
+ $(use_enable cygnal cgibins) \
+ $(use_enable doc docbook) \
+ $(use_enable gnome ghelp) \
+ $(use_enable harden) \
+ $(use_enable kde kparts4) \
+ $(use_enable nls) \
+ $(use_enable nsplugin npapi) \
+ $(use_enable python) \
+ $(use_enable ssh) \
+ $(use_enable ssl) \
+ $(use_enable test testsuite) \
+ $(use_with gconf) \
+ --enable-gui=${gui} \
+ --enable-device=${device} \
+ --enable-extensions=${myext} \
+ --enable-renderer=${renderers} \
+ --enable-media=${media} \
+ ${myconf}
+}
+src_test() {
+ local log=testsuite-results.txt
+ cd testsuite
+ emake check || die "make check failed"
+ ./anaylse-results.sh > $log || die "results analyze failed"
+ cat $log
+}
+src_install() {
+ emake DESTDIR="${D}" install || die "emake install failed"
+
+ # Install nsplugin in directory set by --with-npapi-plugindir.
+ if use nsplugin; then
+ emake DESTDIR="${D}" install-plugin || die "install plugins failed"
+ fi
+
+ # Install kde konqueror plugin.
+ if use kde; then
+ pushd "${S}/plugin/klash4" >& /dev/null || die
+ emake DESTDIR="${D}" install-plugin || die "install kde plugins failed"
+ popd >& /dev/null
+ fi
+ # Create a symlink in /usr/$(get_libdir)/nsbrowser/plugins to the nsplugin install directory.
+ use nsplugin && inst_plugin /usr/$(get_libdir)/gnash/npapi/libgnashplugin.so \
+
+ dodoc AUTHORS ChangeLog NEWS README || die "dodoc failed"
+}
+pkg_postinst() {
+ if use !gnome || use !gstreamer && use !ffmpeg ; then
+ ewarn ""
+ ewarn "Gnash was built without a media handler and or http handler !"
+ ewarn ""
+ ewarn "If you want Gnash to support video then you will need to"
+ ewarn "rebuild Gnash with either the ffmpeg or gstreamer and gnome use flags set."
+ ewarn ""
+ fi
+ ewarn "${PN} is still in heavy development"
+ ewarn "Please first report bugs on upstream gnashdevs and deal with them"
+ ewarn "And then report a Gentoo bug to the maintainer"
+ use kde && kde4-base_pkg_postinst
+}